-- ********** DEFINITION AND GENERIC FUNCTIONS **********

material = {class = "material"}
material.__index = material

function material.new(amb, diff, spec, sh, al)
  local m = {ambient = amb and vector.new(amb) or vector.one(3),
             diffuse = diff and vector.new(diff) or vector.one(3),
             specular = spec and vector.new(spec) or vector.one(3),
             shininess = sh or 1,
             alpha = al or 0}
  setmetatable(m, material)
  return m
end
